/**
 * EpicMusicPlayer Playlistgenerator
 *
 * @author yess
 */

package gui;

import app.Config;
import playlist.Playlists;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.logging.Level;
import java.util.logging.Logger;
import net.iharder.dnd.FileDrop.Listener;

public class JTableDropListener implements Listener, Runnable {

    Playlists myGenerator;
    MainView f;
    Config conf;
    int toList;
    File[] files;

    public JTableDropListener(Playlists gen, MainView f, Config conf) {
        this.myGenerator = gen;
        this.f = f;
        this.conf = conf;


    }

    public void filesDropped(File[] files) {
        this.files = files;
        this.toList = f.getSelectetList();
        Thread thdrop = new Thread(this);
        thdrop.start();
    }

    public void filesDroppedThread(File[] files) {
        // handle file drop
        for (int i = 0; i < files.length; i++) {
            try {
                //System.out.println(files[i].getPath())
                File newfile = files[i];



                //newfile = newfile.replaceAll("\\\\", "/");
                //log("Adding file: "+newfile.getPath());
                System.out.println(newfile.getCanonicalFile());

                // in addon dir?
                File dest = conf.getMusicDir();
                //System.out.println("newfile: " + newfile.getPath());
                //System.out.println("addonpath: " + dest.getPath());
                
                
                // check if dropped file ist in addondir
                if (newfile.getPath().toLowerCase().contains(dest.getPath().toLowerCase())) {
                    //in addondir do not copy
                    myGenerator.addFile(files[i], toList);
                } else {
                    File destf = new File(conf.getMusicDir() + "/" + files[i].getName());
                    if (destf.exists()) {
                        //do not overwrite
                        f.log("Destination file already exist: " + destf);
                        myGenerator.addFile(destf, toList);
                    } else {
                        //copy and add
                        copyAddFiles(files[i].getPath(), destf.getPath());
                    }
                }
            } catch (IOException ex) {
                Logger.getLogger(JTableDropListener.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        f.updatePlaylist();
    }   // end filesDropped

    public void copyAddFiles(String strPath, String dstPath) {

        File src = new File(strPath);
        File dest = new File(dstPath);

        if (src.isDirectory()) {
            //if(dest.exists()!=true)
            dest.mkdirs();
            String list[] = src.list();

            for (int i = 0; i < list.length; i++) {
                String dest1 = dest.getAbsolutePath() + "\\" + list[i];
                String src1 = src.getAbsolutePath() + "\\" + list[i];
                copyAddFiles(src1, dest1);
            }
        } else {
            try {
                if (!src.getName().toUpperCase().endsWith(".MP3")) {
                    if (!src.getName().toUpperCase().endsWith(".OGG")) {
                        f.log("Not a MP3/OGG File.");
                        return;
                    }
                }

                System.out.println("Copying: " + src + " to " + dest);
                f.log("Copying: " + src + " to " + dest);
                FileChannel sourceChannel = new FileInputStream(src).getChannel();
                FileChannel targetChannel = new FileOutputStream(dest).getChannel();
                sourceChannel.transferTo(0, sourceChannel.size(), targetChannel);
                sourceChannel.close();
                targetChannel.close();
                myGenerator.addFile(dest, toList);
            } catch (IOException ex) {
                //Logger.getLogger(FileCopy.class.getName()).log(Level.SEVERE, null, ex);
                f.log("Error at File:" + src + " (" + ex + ")");
            }
        }
    }

    public void run() {
        filesDroppedThread(files);
    }
}
